Loading...
Searching...
No Matches
packet_headergenerator_bb.h
Go to the documentation of this file.
/* -*- c++ -*- */
/* Copyright 2012 Free Software Foundation, Inc.
*
* This file is part of GNU Radio
*
* SPDX-License-Identifier: GPL-3.0-or-later
*
*/
#ifndef INCLUDED_PACKET_HEADERGENERATOR_BB_H
#define INCLUDED_PACKET_HEADERGENERATOR_BB_H
#include <gnuradio/digital/api.h>
#include <gnuradio/digital/packet_header_default.h>
#include <gnuradio/tagged_stream_block.h>
namespace gr {
namespace digital {
/*!
* \brief Generates a header for a tagged, streamed packet.
* \ingroup packet_operators_blk
*
* \details
* Input: A tagged stream. This is consumed entirely, it is not appended
* to the output stream.
* Output: An tagged stream containing the header. The details on the header
* are set in a header formatter object (of type packet_header_default
* or a subclass thereof). If only a number of bits is specified, a
* default header is generated (see packet_header_default).
*/
class DIGITAL_API packet_headergenerator_bb : virtual public tagged_stream_block
{
public:
typedef std::shared_ptr<packet_headergenerator_bb> sptr;
/* \param header_formatter A header formatter object.
* \param len_tag_key Length tag key. Note that for header generation,
* it is irrelevant which tag names are set in the
* formatter object, only this value is relevant!
*/
static sptr make(const packet_header_default::sptr& header_formatter,
const std::string& len_tag_key = "packet_len");
/* \param header_len If this value is given, a packet_header_default
* object is used to generate the header. This is
* the number of bits per header.
* \param len_tag_key Length tag key.
*/
static sptr make(long header_len, const std::string& len_tag_key = "packet_len");
virtual void set_header_formatter(packet_header_default::sptr header_formatter) = 0;
};
} // namespace digital
} // namespace gr
#endif /* INCLUDED_PACKET_HEADERGENERATOR_BB_H */
gr::digital::packet_header_default::sptr
std::shared_ptr< packet_header_default > sptr
Definition packet_header_default.h:40
gr::digital::packet_headergenerator_bb
Generates a header for a tagged, streamed packet.
Definition packet_headergenerator_bb.h:33
gr::digital::packet_headergenerator_bb::set_header_formatter
virtual void set_header_formatter(packet_header_default::sptr header_formatter)=0
gr::digital::packet_headergenerator_bb::sptr
std::shared_ptr< packet_headergenerator_bb > sptr
Definition packet_headergenerator_bb.h:35
gr::digital::packet_headergenerator_bb::make
static sptr make(long header_len, const std::string &len_tag_key="packet_len")
gr::digital::packet_headergenerator_bb::make
static sptr make(const packet_header_default::sptr &header_formatter, const std::string &len_tag_key="packet_len")
gr::tagged_stream_block::tagged_stream_block
tagged_stream_block(void)
Definition tagged_stream_block.h:35
api.h
DIGITAL_API
#define DIGITAL_API
Definition gr-digital/include/gnuradio/digital/api.h:18
gr::digital
Definition adaptive_algorithm.h:22
gr
GNU Radio logging wrapper.
Definition basic_block.h:29
packet_header_default.h
tagged_stream_block.h